-- DurabilityInfosWindow.lua
-- written by Habna


function frmDurabilityInfosWindow()
	frmDI = true;

	wDurability = Turbine.UI.Lotro.Window()
	--wDurability = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	wDurability:SetSize( 300, 90 );
	if TBLocale == "fr" then
		wDurability:SetSize( 400, 90 );
	end
	wDurability:SetPosition( DIWLeft, DIWTop );
	wDurability:SetText( L["DWTitle"] );
	wDurability:SetWantsKeyEvents( true );
	wDurability:SetVisible( true );
	--wDurability:SetZOrder( 2 );
	wDurability:Activate();

	wDurability.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wDurability:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wDurability:SetVisible( not wDurability:IsVisible() );
		end
	end

	wDurability.MouseUp = function( sender, args )
		settings.DurabilityInfos.L = string.format("%.0f", wDurability:GetLeft());
		settings.DurabilityInfos.T = string.format("%.0f", wDurability:GetTop());
		DIWLeft, DIWTop = wDurability:GetPosition();
		SaveSettings( false );
	end

	wDurability.Closing = function( sender, args ) -- Function for the Upper right X icon
		wDurability:SetWantsKeyEvents( false );
		wDurability = nil;
		frmDI = nil;
	end
	-- **^
	-- **v Show Icon in tooltip? v**
	local TTIcon = Turbine.UI.Lotro.CheckBox();
	TTIcon:SetParent( wDurability );
	TTIcon:SetPosition( 30, 40 );
	TTIcon:SetText( L["DIIcon"] );
	TTIcon:SetSize( TTIcon:GetTextLength() * 8.5, 20 );
	--TTIcon:SetVisible( true );
	--TTIcon:SetEnabled( false );
	TTIcon:SetChecked( DIIcon );
	TTIcon:SetForeColor( Color["rustedgold"] );

	TTIcon.CheckedChanged = function( sender, args )
		DIIcon = TTIcon:IsChecked();
		settings.DurabilityInfos.I = DIIcon;
		SaveSettings( false );
	end
	-- **^
	-- **v Show Item Name in tooltip? v**
	local TTItemName = Turbine.UI.Lotro.CheckBox();
	TTItemName:SetParent( wDurability );
	TTItemName:SetPosition( 30, TTIcon:GetTop() + TTIcon:GetHeight() );
	TTItemName:SetText( L["DIText"] );
	TTItemName:SetSize( TTItemName :GetTextLength() * 8.5, 20 );
	--TTItemName:SetVisible( true );
	--TTItemName:SetEnabled( false );
	TTItemName:SetChecked( DIText );
	TTItemName:SetForeColor( Color["rustedgold"] );

	TTItemName.CheckedChanged = function( sender, args )
		DIText = TTItemName:IsChecked();
		settings.DurabilityInfos.N = DIText;
		SaveSettings( false );
	end
	-- **^
end