-- InfamyWindow.lua
-- written by Habna


function frmInfamyWindow()
	frmIF = true;

	wInfamy = Turbine.UI.Lotro.Window()
	--wInfamy = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	wInfamy:SetPosition( IFWLeft, IFWTop );
	--wInfamy:SetSize( 300, 80 );
	wInfamy:SetText( L["IFWTitle"] );
	wInfamy:SetWantsKeyEvents( true );
	wInfamy:SetVisible( true );
	--wInfamy:SetZOrder( 2 );
	wInfamy:Activate();

	wInfamy.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wInfamy:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wInfamy:SetVisible( not wInfamy:IsVisible() );
		elseif ( args.Action == 162 ) then --Enter key was pressed
			buttonSave.Click( sender, args );
		end
	end

	wInfamy.MouseUp = function( sender, args )
		settings.Infamy.L = string.format("%.0f", wInfamy:GetLeft());
		settings.Infamy.T = string.format("%.0f", wInfamy:GetTop());
		IFWLeft, IFWTop = wInfamy:GetPosition();
		SaveSettings( false );
	end

	wInfamy.Closing = function( sender, args ) -- Function for the Upper right X icon
		wInfamy:SetWantsKeyEvents( false );
		wInfamy = nil;
		frmIF = nil;
	end
	-- **^

	local IFWCtr = Turbine.UI.Control();
	IFWCtr:SetParent( wInfamy );
	IFWCtr:SetPosition( 15, 50 )
	IFWCtr:SetZOrder( 2 );
	--IFWCtr:SetBackColor( Color["red"] ); -- debug purpose

	local lblName = Turbine.UI.Label();
	lblName:SetParent( IFWCtr );
	--lblName:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );
	lblName:SetText( L["IFIF"] );
	lblName:SetPosition( 0, 2 );
	lblName:SetSize( lblName:GetTextLength() * 7.5, 15 ); --Auto size with text lenght
	lblName:SetForeColor( Color["rustedgold"] );
	lblName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--lblName:SetBackColor( Color["red"] ); -- debug purpose

	local txtInfamy = Turbine.UI.Lotro.TextBox();
	txtInfamy:SetParent( IFWCtr );
	txtInfamy:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );
	txtInfamy:SetText( InfamyPTS );
	txtInfamy:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	txtInfamy:SetPosition( lblName:GetLeft()+lblName:GetWidth()+5, lblName:GetTop()-2 );
	txtInfamy:SetSize( 80, 20 );
	txtInfamy:SetMultiline( false );
	if PlayerAlign == 2 then txtInfamy:SetBackColor( Color["red"] ); end

	txtInfamy.FocusGained = function( sender, args )
		txtInfamy:SelectAll();
		txtInfamy:SetWantsUpdates( true );
	end

	txtInfamy.FocusLost = function( sender, args )
		txtInfamy:SetWantsUpdates( false );
	end

	txtInfamy.Update = function( sender, args )
		local parsed_text = txtInfamy:GetText();

		if tonumber(parsed_text) == nil or string.find(parsed_text,"%.") ~= nil then
			txtInfamy:SetText( string.sub( parsed_text, 1, string.len(parsed_text)-1 ) );
			--txtInfamy:Focus();
			return
		elseif string.len(parsed_text) > 1 and string.sub(parsed_text,1,1) == "0" then
			txtInfamy:SetText( string.sub( parsed_text, 2 ) );
			return
		end
	end

	buttonSave = Turbine.UI.Lotro.Button();
	buttonSave:SetParent( IFWCtr );
	buttonSave:SetText( L["PWSave"] );
	buttonSave:SetSize( buttonSave:GetTextLength() * 10, 15 ); --Auto size with text lenght
	buttonSave:SetPosition( txtInfamy:GetLeft()+txtInfamy:GetWidth()+5, txtInfamy:GetTop() );
	--buttonSave:SetEnabled( true );

	buttonSave.Click = function( sender, args )
		local parsed_text = txtInfamy:GetText();

		if parsed_text == "" then
			txtInfamy:SetText( "0" );
			txtInfamy:Focus();
			return
		elseif parsed_text == _G.InfamyPTS then
			txtInfamy:Focus();
			return
		end
			
		InfamyPTS = txtInfamy:GetText();
		
		for i = 0, 14 do
			if tonumber(InfamyPTS) >= _G.InfamyRanks[i] and tonumber(InfamyPTS) < _G.InfamyRanks[i+1] then InfamyRank = i; break end
		end

		settings.Infamy.P = string.format("%.0f", InfamyPTS);
		settings.Infamy.K = string.format("%.0f", InfamyRank);
		SaveSettings( false );

		txtInfamy:Focus();

		UpdateInfamy();
	end

	IFWCtr:SetSize( lblName:GetWidth()+txtInfamy:GetWidth()+buttonSave:GetWidth()+10, 20 );
	wInfamy:SetSize( IFWCtr:GetWidth()+30, 80 );

	txtInfamy:Focus();
end