-- VaultWindow.lua
-- written by Habna


function frmVault()
	frmVT = true;
	tvaultpack = vaultpack;
	SelCN = PN;
	import (AppClassD.."ComboBox");
	PNDD = HabnaPlugins.TitanBar.Class.ComboBox();

	-- **v Set some window stuff v**
	wVault = Turbine.UI.Lotro.Window()
	wVault:SetText( L["MVault"] );
	wVault:SetPosition( VTWLeft, VTWTop );
	wVault:SetWidth( 390 );
	wVault:SetWantsKeyEvents( true );
	wVault:SetVisible( true );
	--wVault:SetZOrder( 2 );
	--wVault:Activate();

	wVault.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wVault:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wVault:SetVisible( not wVault:IsVisible() );
		end
	end

	wVault.MouseDown = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then dragging = true; end
	end

	wVault.MouseMove = function( sender, args )
		if dragging then if PNDD.dropped then PNDD:CloseDropDown(); end end
	end

	wVault.MouseUp = function( sender, args )
		dragging = false;
		settings.Vault.L = string.format("%.0f", wVault:GetLeft());
		settings.Vault.T = string.format("%.0f", wVault:GetTop());
		VTWLeft, VTWTop = wVault:GetPosition();
		SaveSettings( false );
	end

	wVault.Closing = function( sender, args ) -- Function for the Upper right X icon
		PNDD.dropDownWindow:SetVisible(false);
		wVault:SetWantsKeyEvents( false );
		RemoveCallback( tvaultpack, "CountChanged" );
		wVault = nil;
		frmVT = nil;
	end
	-- **^
	-- **v Character name - label & DropDown box v**
	local newt = {}
	for i in pairs(PlayerVault) do
		if string.sub( i, 1, 1 ) == "~" then PlayerVault[i] = nil; else table.insert(newt,i); end --Delete session play character
	end
	table.sort(newt);
	
	PNDD:SetParent( wVault );
	PNDD:SetSize( 159, 19 );
	PNDD:SetPosition( 15, 35 );
	--PNDD:SetVisible( true );

	for k,v in pairs(newt) do
		PNDD:AddItem(v, k);
		if v == PN then PNDD:SetSelection(k); end
	end

	PNDD.ItemChanged = function( sender, args ) -- The event that's executed when a menu item is clicked.
		SelCN = PNDD.label:GetText();
		vaultpackCount = 0;
		for k, v in pairs(PlayerVault[SelCN]) do vaultpackCount = vaultpackCount + 1; end
		SetVaultPack(SelCN);
	end
	-- **^
	-- **v Set the itemlistbox border v**
	wVault.ListBoxBorder = Turbine.UI.Control();
	wVault.ListBoxBorder:SetParent( wVault );
	wVault.ListBoxBorder:SetPosition( 15, 60 );
	wVault.ListBoxBorder:SetWidth( wVault:GetWidth()-30 );
	wVault.ListBoxBorder:SetBackColor( Color["grey"] );
	wVault.ListBoxBorder:SetVisible( true );
	-- **^
	-- **v Set the itemlistbox v**
	wVault.ListBox = Turbine.UI.ListBox();
	wVault.ListBox:SetParent( wVault );
	wVault.ListBox:SetPosition( wVault.ListBoxBorder:GetLeft() + 2, wVault.ListBoxBorder:GetTop() + 2 );
	wVault.ListBox:SetWidth( wVault.ListBoxBorder:GetWidth() - 4 );
	wVault.ListBox:SetMaxItemsPerLine( 1 );
	wVault.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wVault.ListBox:SetBackColor( Color["black"] );
	-- **^
	-- **v Set the scrollbar v**
	wVault.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wVault.ListBoxScrollBar:SetParent( wVault );
	wVault.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wVault.ListBox:SetVerticalScrollBar( wVault.ListBoxScrollBar );
	wVault.ListBoxScrollBar:SetPosition( wVault:GetWidth()-28, wVault.ListBox:GetTop() + 2 );
	wVault.ListBoxScrollBar:SetWidth( 10 );
	-- **^
	
	vaultpackCount = 0;
	if PlayerVault[PN] ~= nil then for k, v in pairs(PlayerVault[PN]) do vaultpackCount = vaultpackCount + 1; end end

	AddCallback(tvaultpack, "CountChanged", 
		function(sender, args)
		if frmVT then vaultpackCount = 0;
			if SelCN == PN then
				for k, v in pairs(PlayerVault[SelCN]) do vaultpackCount = vaultpackCount + 1; end
				SetVaultPack(SelCN);
			end
		end
	end);

	SetVaultPack(SelCN);
end

function SetVaultPack(n)
	wVault.ListBox:ClearItems();
	itemCtl = {};

	if vaultpackCount == 0 then --Vault list empty
		-- Item control
		itemCtl = Turbine.UI.Control();
		itemCtl:SetSize( wVault.ListBox:GetWidth(), 35 );

		local lblmgs = Turbine.UI.Label();
		lblmgs:SetParent( itemCtl );
		lblmgs:SetText( L["VTnd"] );
		lblmgs:SetPosition( 0, 0 );
		lblmgs:SetSize( itemCtl:GetWidth(), itemCtl:GetHeight() );
		lblmgs:SetForeColor( Color["green"] );
		lblmgs:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

		wVault.ListBox:SetHeight( lblmgs:GetHeight() );
		wVault.ListBoxBorder:SetHeight( wVault.ListBox:GetHeight()+4 );
		wVault:SetHeight( itemCtl:GetHeight()+85 );

		wVault.ListBox:AddItem( itemCtl );
	else
		for i = 1, vaultpackCount do
			-- Item control
			itemCtl[i] = Turbine.UI.Control();
			itemCtl[i]:SetSize( wVault.ListBox:GetWidth()-12, 35 );

			-- Item Background/Underlay/Shadow/Image
			local itemBG = Turbine.UI.Control();
			itemBG:SetParent( itemCtl[i] );
			itemBG:SetSize( 32, 32 );
			itemBG:SetPosition( 3, 3 );
			itemBG:SetBackground(tonumber(PlayerVault[n][tostring(i)].B));
			itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
			local itemU = Turbine.UI.Control();
			itemU:SetParent( itemCtl[i] );
			itemU:SetSize( 32, 32 );
			itemU:SetPosition( 3, 3 );
			if PlayerVault[n][tostring(i)].U ~= "0" then itemU:SetBackground(tonumber(PlayerVault[n][tostring(i)].U)); end
			itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local itemS = Turbine.UI.Control();
			itemS:SetParent( itemCtl[i] );
			itemS:SetSize( 32, 32 );
			itemS:SetPosition( 3, 3 );
			if PlayerVault[n][tostring(i)].S ~= "0" then itemS:SetBackground(tonumber(PlayerVault[n][tostring(i)].S)); end
			itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local item = Turbine.UI.Control();
			item:SetParent( itemCtl[i] );
			item:SetSize( 32, 32 );
			item:SetPosition( 3, 3 );
			item:SetBackground(tonumber(PlayerVault[n][tostring(i)].I));
			item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			-- Item Quantity
			local itemQTE = Turbine.UI.Label();
			itemQTE:SetParent( itemCtl[i] );
			itemQTE:SetSize( 32, 15 );
			itemQTE:SetPosition( -4, 16 );
			itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
			itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
			itemQTE:SetOutlineColor( Color["black"] );
			itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
			itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemQTE:SetForeColor( Color["nicegold"] );
			itemQTE:SetText(tonumber(PlayerVault[n][tostring(i)].N));

			-- Item name
			local itemLbl = Turbine.UI.Label();
			itemLbl:SetParent( itemCtl[i] );
			itemLbl:SetSize( itemCtl[i]:GetWidth() - 35, 35 );
			itemLbl:SetPosition( 37, 2 );
			itemLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
			itemLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
			itemLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemLbl:SetForeColor( Color["white"] );
			itemLbl:SetText( PlayerVault[n][tostring(i)].T );

			wVault.ListBox:AddItem( itemCtl[i] );
		end

		wVault.ListBoxBorder:SetHeight( 390 );
		wVault.ListBox:SetHeight( wVault.ListBoxBorder:GetHeight() - 4 );
		wVault.ListBoxScrollBar:SetHeight( wVault.ListBox:GetHeight() - 2 );
		wVault:SetHeight( 472 );
	end

	-- Set window title
	--wVault:SetText( L["MVault"] .. " - " .. L["VTFree"] .. ( vaultpackSize - vaultpackCount ) .. L["VTUsed"] .. vaultpackCount .. L["VTMax"] .. vaultpackSize );
end