-- WalletWindow.lua
-- Written by Habna


function frmWalletWindow()
	frmWI = true;
	wcur = nil;
	import (AppClassD.."ComboBox");

	wWallet = Turbine.UI.Lotro.Window();
	wWallet:SetSize( 280, 260 );
    wWallet:SetPosition( WIWLeft, WIWTop );
	wWallet:SetText( L["MBag"] );
	wWallet:SetVisible( true );
	wWallet:SetWantsKeyEvents( true );
	--wWallet:SetZOrder( 2 );
	wWallet:Activate();

	wWallet.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wWallet:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key or 'ctrl + \' is press
			wWallet:SetVisible( not wWallet:IsVisible() );
		elseif ( args.Action == 162 ) then --Enter key was pressed
			WIbutSave.Click( sender, args );
		end
	end

	wWallet.MouseDown = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then dragging = true; end
	end

	wWallet.MouseMove = function( sender, args )
		if dragging then if WIDD.dropped then WIDD:CloseDropDown(); end end
	end

	wWallet.MouseUp = function( sender, args )
		dragging = false;
		settings.Wallet.L = string.format("%.0f", wWallet:GetLeft());
		settings.Wallet.T = string.format("%.0f", wWallet:GetTop());
		WIWLeft, WIWTop = wWallet:GetPosition();
		SaveSettings( false );
	end

	wWallet.Closing = function( sender, args )
		--opt_WI:SetEnabled( true );
		WIDD.dropDownWindow:SetVisible(false);
		wWallet:SetWantsKeyEvents( false );
		wWallet = nil;
		frmWI = nil;
	end
	
	local WIlbltext = Turbine.UI.Label();
	WIlbltext:SetParent( wWallet );
	WIlbltext:SetText( L["WIt"] );
	WIlbltext:SetPosition( 20, 35);
	WIlbltext:SetSize( wWallet:GetWidth()-40 , 35 );
	WIlbltext:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	WIlbltext:SetForeColor( Color["green"] );

	WIListBox = Turbine.UI.ListBox();
	WIListBox:SetParent( wWallet );
	WIListBox:SetZOrder( 1 );
	WIListBox:SetPosition( 20, WIlbltext:GetTop()+WIlbltext:GetHeight()+10 );
	WIListBox:SetSize( wWallet:GetWidth()-40, wWallet:GetHeight()-95 );
	WIListBox:SetMaxItemsPerLine( 1 );
	WIListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	--WIListBox:SetBackColor( Color["red"] ); --debug purpose

	WIListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	WIListBoxScrollBar:SetParent( wWallet );
	WIListBoxScrollBar:SetZOrder( 1 );
	WIListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	WIListBox:SetVerticalScrollBar( WIListBoxScrollBar );
	WIListBoxScrollBar:SetPosition( WIListBox:GetWidth()+10, WIListBox:GetTop() );
	WIListBoxScrollBar:SetSize( 10, WIListBox:GetHeight() );

	WIWCtr = Turbine.UI.Control();
	WIWCtr:SetParent( wWallet );
	WIWCtr:SetPosition( WIListBox:GetLeft(), WIListBox:GetTop() );
	WIWCtr:SetSize( WIListBox:GetWidth(), WIListBox:GetHeight() );
	WIWCtr:SetZOrder( 0 );
	WIWCtr:SetVisible( false );
	WIWCtr:SetBlendMode( 5 );
	WIWCtr:SetBackground( 0x4100014c );

	WIWCtr.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			WIDD.Cleanup();
			WIWCtr:SetVisible( false );
			WIWCtr:SetZOrder( 0 );
		end
	end

	WIlblFN = Turbine.UI.Label();
	WIlblFN:SetParent( WIWCtr );
	WIlblFN:SetPosition( 0 , WIWCtr:GetHeight()/2 - 40 );
	WIlblFN:SetSize( WIWCtr:GetWidth() , 15 );
	WIlblFN:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
	WIlblFN:SetFontStyle( Turbine.UI.FontStyle.Outline );
	WIlblFN:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	WIlblFN:SetForeColor( Color["rustedgold"] );

	WICBO = { L["WIot"], L["WIiw"], L["WIds"] } --Combobox options

	WIDD = HabnaPlugins.TitanBar.Class.ComboBox();
	WIDD:SetParent( WIWCtr );
	WIDD:SetSize( 170, 19 );
	WIDD:SetPosition( WIWCtr:GetWidth()/2 - WIDD:GetWidth()/2, WIlblFN:GetTop()+WIlblFN:GetHeight()+10 );
	--WIDD:SetVisible( true );
	
	for k,v in pairs(WICBO) do WIDD:AddItem(v, k); end

	WIbutSave = Turbine.UI.Lotro.Button();
	WIbutSave:SetParent( WIWCtr );
	WIbutSave:SetText( L["PWSave"] );
	WIbutSave:SetSize( WIbutSave:GetTextLength() * 10, 15 ); --Auto size with text lenght
	WIbutSave:SetPosition( WIWCtr:GetWidth()/2 - WIbutSave:GetWidth()/2, WIDD:GetTop()+WIDD:GetHeight()+10 );
	--WIbutSave:SetEnabled( true );

	WIbutSave.Click = function( sender, args )
		WIWCtr:SetVisible( false );
		WIWCtr:SetZOrder( 0 );

		SelIndex = WIDD:GetSelection();
		--Where-> 1: On TitanBar / 2: In wallet control tooltip / 3: Don't show
		if wcur == L["MGSC"] then
			MIWhere = SelIndex; settings.Money.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowMoney then ShowHideMoney(); end
			else if ShowMoney then ShowHideMoney(); end end
		elseif wcur == L["MDP"] then
			DPWhere = SelIndex; settings.DestinyPoints.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowDestinyPoints then ShowHideDestinyPoints(); end
			else if ShowDestinyPoints then ShowHideDestinyPoints(); end end
		elseif wcur == L["MSP"] then
			SPWhere = SelIndex; settings.Shards.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowShards then ShowHideShards(); end
			else if ShowShards then ShowHideShards(); end end
		elseif wcur == L["MSM"] then
			SMWhere = SelIndex; settings.SkirmishMarks.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowSkirmishMarks then ShowHideSkirmishMarks(); end
			else if ShowSkirmishMarks then ShowHideSkirmishMarks(); end end
		elseif wcur == L["MMP"] then
			MPWhere = SelIndex; settings.Medallions.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowMedallions then ShowHideMedallions(); end
			else if ShowMedallions then ShowHideMedallions(); end end
		elseif wcur == L["MSL"] then
			SLWhere = SelIndex; settings.Seals.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowSeals then ShowHideSeals(); end
			else if ShowSeals then ShowHideSeals(); end end
		elseif wcur == L["MCP"] then
			CPWhere = SelIndex; settings.Commendations.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowCommendations then ShowHideCommendations(); end
			else if ShowCommendations then ShowHideCommendations(); end end
		elseif wcur == L["MTP"] then
			TPWhere = SelIndex; settings.TurbinePoints.W = string.format("%.0f", SelIndex);
			if SelIndex == 1 then if not ShowTurbinePoints then ShowHideTurbinePoints(); end
			else if ShowTurbinePoints then ShowHideTurbinePoints(); end end
		end

		SaveSettings( false );
	end

	RefreshWIListBox();
end

function RefreshWIListBox()
	WIListBox:ClearItems();
	
	for i = 1, #MenuItem do		
		--**v Control of all data v**
		local RPCtr = Turbine.UI.Control();
		RPCtr:SetParent( WIListBox );
		RPCtr:SetSize( WIListBox:GetWidth(), 20 );
		--**^
		
		-- Wallet currency name
		local curLbl = Turbine.UI.Label();
		curLbl:SetParent( RPCtr );
		curLbl:SetText( MenuItem[WalletOrder[i]] );
		curLbl:SetSize( WIListBox:GetWidth(), 20 );
		curLbl:SetPosition( 0, 0 );
		curLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
		curLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		curLbl:SetForeColor( Color["nicegold"] );
		--curLbl:SetBackColor( Color["blue"] ); --debug purpose

		curLbl.MouseClick = function( sender, args )
			if ( args.Button == Turbine.UI.MouseButton.Right ) then
				wcur = MenuItem[WalletOrder[i]];
				WIlblFN:SetText( wcur );
				
				if wcur == L["MGSC"] then tw = settings.Money.W;
				elseif wcur == L["MDP"] then tw = settings.DestinyPoints.W;
				elseif wcur == L["MSP"] then tw = settings.Shards.W;
				elseif wcur == L["MSM"] then tw = settings.SkirmishMarks.W;
				elseif wcur == L["MMP"] then tw = settings.Medallions.W;
				elseif wcur == L["MSL"] then tw = settings.Seals.W;
				elseif wcur == L["MCP"] then tw = settings.Commendations.W;
				elseif wcur == L["MTP"] then tw = settings.TurbinePoints.W; end
				
				for k, v in pairs(WICBO) do if k == tonumber(tw) then WIDD:SetSelection(k); end end

				WIWCtr:SetVisible( true );
				WIWCtr:SetZOrder( 2 );
			end
		end

		WIListBox:AddItem( RPCtr );
	end
end